unit CodeExplorer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ImgList;

type
  TCodeExplorerForm = class(TForm)
    TreeImages: TImageList;
    TreeView: TTreeView;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure InsertIntoList(Item: string; LineNumber: Integer; Child: Boolean);
  end;

var
  CodeExplorerForm: TCodeExplorerForm;

implementation

uses Uconst;

{$R *.DFM}

procedure TCodeExplorerForm.FormShow(Sender: TObject);
begin
   Left:= 0;
end;

procedure TCodeExplorerForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   Action:= caFree;
end;

procedure TCodeExplorerForm.InsertIntoList(Item: string; LineNumber: Integer; Child: Boolean);
var
 CurrentItem                  : Integer;
 Added                        : Boolean;
 Node                         : TTreeNode;
begin
 Added := False;
 for CurrentItem := 0 to TreeView.Items.Count - 1 do
 begin
  if TreeView.Items[CurrentItem].Text = Item then // Procedure/function is in list
  begin
   TreeView.Items[CurrentItem].Data := Pointer(Linenumber); // Change Linenumber
   Added := True;
   break;
  end;
 end;
 if not added then // new procedure/function
 begin
  if child then // it is a procedure/function, so add node as child of topnode
  begin
   Node := TreeView.Items.AddChildObject(TreeView.TopItem, Item, Pointer(LineNumber));
   Node.ImageIndex := 1;
   Node.SelectedIndex := 1;
  end
  else // it is 'implementation', add it as first node
  begin
   Node := TreeView.Items.AddObject(TreeView.TopItem, Item, Pointer(LineNumber));
   Node.ImageIndex := 0;
   Node.SelectedIndex := 0;
  end;
  TreeView.TopItem.Expand(False);
 // TreeView.CustomSort(@CustomSortProc, 0); // sort the list
 end;
end;

procedure TCodeExplorerForm.FormActivate(Sender: TObject);
begin
  // ActivePasEditor.RefreshAllTokens;
end;

end.
