unit Utools;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TTools = class(TForm)
    ListBox1: TListBox;
    btnAdd: TButton;
    btnDelete: TButton;
    btnEdit: TButton;
    btnClose: TButton;
    btnHelp: TButton;
    Label1: TLabel;
    sbDown: TSpeedButton;
    sbUp: TSpeedButton;
    procedure btnCloseClick(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnEditClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure sbDownClick(Sender: TObject);
    procedure sbUpClick(Sender: TObject);
    procedure btnHelpClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Tools: TTools;

implementation

uses UToolProperty, utils, Uconst, MainForm;

{$R *.DFM}

procedure TTools.btnCloseClick(Sender: TObject);
begin
   ModalResult:=mrOK;
   FMainForm.OpenTools;
end;

procedure TTools.btnAddClick(Sender: TObject);
begin
   CreateShowModal(TToolProperty);
end;

procedure TTools.ListBox1Click(Sender: TObject);
begin
   btnDelete.Enabled:=True;
   btnEdit.Enabled:=True;
end;

procedure TTools.FormCreate(Sender: TObject);
var
   List:TStringList;
begin
   List:=TStringList.Create;
   IniFile.ReadSection('Tools',List);
   ListBox1.Items:=List;
end;

procedure TTools.btnEditClick(Sender: TObject);
var
   ToolProperty:TToolProperty;
begin
   ToolProperty:=TToolProperty.Create(self);
   with ToolProperty do begin
      edTitle.Text:=ListBox1.Items[ListBox1.ItemIndex];
      edProgram.Text:=IniFile.ReadString('Tools',ListBox1.Items[ListBox1.ItemIndex],'');
      ShowModal;
      Free;
   end;
end;

procedure TTools.btnDeleteClick(Sender: TObject);
begin
   ListBox1.Items.Delete(ListBox1.ItemIndex);
end;


procedure TTools.sbDownClick(Sender: TObject);
begin
   if ListBox1.ItemIndex = -1 then Exit;
   if ((ListBox1.ItemIndex + 1) = ListBox1.Items.Count) then Exit;
   ListBox1.Items.Exchange(ListBox1.ItemIndex, ListBox1.ItemIndex + 1);
   ListBox1.ItemIndex:= ListBox1.ItemIndex + 1;
end;

procedure TTools.sbUpClick(Sender: TObject);
begin
   if (ListBox1.ItemIndex = -1) or (ListBox1.ItemIndex = 0) then Exit;
   ListBox1.Items.Exchange(ListBox1.ItemIndex, ListBox1.ItemIndex - 1);
   ListBox1.ItemIndex:= ListBox1.ItemIndex - 1;
end;

procedure TTools.btnHelpClick(Sender: TObject);
var
  KeyWord:string;
begin
   KeyWord:= 'Tools Options dialog box';
   Application.HelpCommand(HELP_KEY,longint(KeyWord));
end;

end.
